# Readme - Code Samples for Chapter 27, Localization

This chapter contains the following code samples:

* NumberAndDateFormatting (localized format strings)
* SortingDemo (sorting with different cultures and using the invariant culture)
* CreateResource (using `ResourceReader` and `ResourceWriter`)
* UWPCultureDemo (showing all cultures and regions with a UWP application, this sample requires the C++ compiler installed with Visual Studio for the TreeView control that is used)
* ResourcesDemo (accessing resources using `ResourceManager`)
* WebApplication (using `CultureInfo` and `IStringLocalizer` with ASP.NET Core)
* ASPNETCoreMVCSample (localizing with controllers, views, and data annotations)
* UWPLocalization (localizing with UWP and XLF)

To build and run the .NET Core samples, please install one of these tools:

* Visual Studio 2017 Update 5 with the .NET Core workload
* Visual Studio for Mac
* Visual Studio Code

The UWPLocalization and UWPCultureDemo samples needs Windows 10 and Visual Studio 2017 with the Universal Windows Platform development workload. The other samples can be used on other platforms.
The UWPCultureDemo uses a TreeView control built with C++. To compile this project, you need to install the C++ component with the Universal Windows Platform workload with the Visual Studio Installer.

Please download and install the tools from [.NET Core downloads](https://www.microsoft.com/net/core).
 
For code comments and issues please check [Professional C#'s GitHub Repository](https://github.com/ProfessionalCSharp/ProfessionalCSharp7)

Please check my blog [csharp.christiannagel.com](https://csharp.christiannagel.com "csharp.christiannagel.com") for additional information for topics covered in the book.

Thank you!