# Readme - Code Samples for Chapter 24, Security

This chapter contains the following code samples:

* Authentication
    * WindowsPrincipal (`WindowsIdentity` and `WindowsPrincipal`)
* Encryption
    * SigningDemo (signing using `ECDsaCng`)
    * SecureTransfer (encrypting and decrypting a message, this sample requires .NET 4.6)
    * RSASample (signing and hashing with `RSACng`)
* Data Protection
    * DataProtectionSample (use data protection with Microsoft.AspNetCore.DataProtection)
* Access Control
    * FileAccessControl (read file access using `FileSecurity` and  `FileSystemAccessRule`)

To build and run the .NET Core samples, please install one of these tools:

* Visual Studio 2017 Update 5 with the .NET Core workload
* Visual Studio for Mac
* Visual Studio Code

Please download and install the tools from [.NET Core downloads](https://www.microsoft.com/net/core).
 
For code comments and issues please check [Professional C#'s GitHub Repository](https://github.com/ProfessionalCSharp/ProfessionalCSharp7)

Please check my blog [csharp.christiannagel.com](https://csharp.christiannagel.com "csharp.christiannagel.com") for additional information for topics covered in the book.

Thank you!