# Readme - Code Samples for Chapter 16, Reflection, Metadata, and Dynamic Programming

This chapter contains the following code samples:

* Reflection
    * LookupWhatsNew (Reading custom attributes dynamically)
    * VectorClass (Library, custom attributes annotated)
    * WhatsNewAttributes (Library, defines custom attributes)
    * TypeView (Use reflection to get information about types)
* Dynamic Programming
    * CalculatorLib (Library that will be loaded dynamically)
    * ClientApp (console app loading CalculatorLib dynamically)
    * DecompileSample (*dynamic* keyword for checking the IL code differences
    * DynamicFileReader (parsing a file and making use of *dynamic*)
    * DynamicSample (a custom class using *DynamicObject*)

To build and run the .NET Core samples, please install one of these tools:

* Visual Studio 2017 Update 5 with the .NET Core workload
* Visual Studio for Mac
* Visual Studio Code

Please download and install the tools from [.NET Core downloads](https://www.microsoft.com/net/core).
 
For code comments and issues please check [Professional C#'s GitHub Repository](https://github.com/ProfessionalCSharp/ProfessionalCSharp7)

Please check my blog [csharp.christiannagel.com](https://csharp.christiannagel.com "csharp.christiannagel.com") for additional information for topics covered in the book.

Thank you!