# Readme - Code Samples for Chapter 29, Tracing, Logging, and Analytics

This chapter contains the following code samples:

* EventSourceSamples
    * SimpleEventSourceSample (EventSource)
    * EventSourceSampleInheritance (inheriting from EventSource)
    * EventSourceSampleAnnotations (additional manifest information)
    * MyApplicationEvents (library with events) - with client app ClientApp
* LoggingSample
    * LoggingSample (ILogger interface, providers)
    * LoggingScopeSample (using scopes)
    * LoggingConfigurationSample (configure logging with a config file)
    * LoggingWithoutDI (configure logging without dependency injection)
* WinAppAnalytics (Windows App)

The WinAppAnalytics project requires a Windows system. All other apps can run on other platforms.

To build and run the .NET Core samples, please install one of these tools:

* Visual Studio 2017 Update 5 with the .NET Core workload
* Visual Studio for Mac
* Visual Studio Code

Please download and install the tools from [.NET Core downloads](https://www.microsoft.com/net/core).
 
For code comments and issues please check [Professional C#'s GitHub Repository](https://github.com/ProfessionalCSharp/ProfessionalCSharp7)

Please check my blog [csharp.christiannagel.com](https://csharp.christiannagel.com "csharp.christiannagel.com") for additional information for topics covered in the book.

Thank you!